function SpawnObject(t, x, y, id, team)
	for _, id in pairs(player(0, "table")) do
		if ((x*32 + 16 - player(id, "x"))^2 + (y*32 + 16 - player(id, "y"))^2)^0.5 < 400 then
			parse("sv_sound2 "..id.." player/build.wav")
		end
	end

	local ObjectTableA = object(0, "table")
	parse("spawnobject "..t.." "..x.." "..y.." 0 0 "..(id and player(id, "exists") and player(id, "team") or team or 0).." "..(id or 0))
	local ObjectTableB = object(0, "table")
	for Key, Value in pairs(ObjectTableB) do
		if ObjectTableA[Key] ~= Value then
			return Value
		end
	end
end

function AngleBetween(...)
	if #arg < 4 then return nil end
	local Angle = math.atan2(arg[2] - arg[4],arg[1] - arg[3]) - math.pi/2
	if Angle < -math.pi then
		Angle = Angle + (math.pi*2)
	end
	return Angle
end

function ObjectFreeline(x,y,x2,y2)
	local Angle = math.atan2(y - y2,x - x2) - math.pi/2
	if Angle < -math.pi then Angle = Angle + (math.pi*2) end

	local Dist = math.sqrt((x-x2)^2 + (y-y2)^2)
	local ValueX = math.sin(Angle)
	local ValueY = math.cos(Angle)
	x = x + ValueX * 37
	y = y - ValueY * 37
	for i = 1, Dist - 37 do
		x = x + ValueX
		y = y - ValueY
		if tile(math.floor(x/32), math.floor(y/32), "wall") then
			return false
		end
	end
	return true
end

Turrets = {}
TurretsSpawned = {}
TurretTeamColor = {
	[0] = {255, 255, 0},
	[1] = {255, 0, 0},
	[2] = {0, 0, 255}
}

RocketTurret = {}
RocketTurret.FireDelay = 0.6
RocketTurret.TweenDelay = 0.3
RocketTurret.TargetDelay = 0.4
RocketTurretMT = {__index = RocketTurret}
function RocketTurret:Fire()
	local ObjectRot = object(self.Image[2], "rot")
	local RadAngle = math.rad(ObjectRot)
	local ShootX = self.x + math.sin(RadAngle) * 24
	local ShootY = self.y - math.cos(RadAngle) * 24
	parse("spawnprojectile "..self.Player.." 48 "..ShootX.." "..ShootY.." "..self.TargetDistance.." "..ObjectRot)
end

function RocketTurret:TargetAble(id)
	if game("sv_gamemode") == "1" then
		return object(self.ID, "player") ~= id
	end
	return self.Team ~= player(id, "team")
end

function RocketTurret:Visible(id)
	return player(id, "health") > 0 and math.abs(player(id, "x") - self.x) < 320 and math.abs(player(id, "y") - self.y) < 240 and ObjectFreeline(self.x, self.y, player(id,"x"), player(id,"y"))
end

function RocketTurret:Update()
	local Angle = object(self.Image[2], "rot")
	if os.clock() - self.LastTarget >= self.TargetDelay then
		local ClosestTarget
		for _, id in pairs(player(0,"tableliving")) do
			if self:TargetAble(id) and self:Visible(id) then
				local Distance = math.sqrt((self.x - player(id, "x"))^2 + (self.y - player(id,"y"))^2)
				if not ClosestTarget or Distance < ClosestTarget[2] then
					ClosestTarget = {id, Distance}
				end
			end
		end
		self.Target = ClosestTarget and ClosestTarget[1] or 0
		self.TargetDistance = ClosestTarget and ClosestTarget[2] or 0
		self.LastTarget = os.clock()
	end

	if player(self.Target, "exists") then
		Angle = math.deg(AngleBetween(self.x, self.y, player(self.Target, "x"), player(self.Target, "y")))
	end

	if os.clock() - self.LastTween >= self.TweenDelay then
		if object(self.Image[2], "rot") ~= Angle then
			tween_rotate(self.Image[2], self.TweenDelay * 1000 - 20, Angle)
		end
		self.LastTween = os.clock()
	end

	if os.clock() - self.LastFire >= self.FireDelay and player(self.Target, "exists") and self:Visible(self.Target) then
		self:Fire()
		self.LastFire = os.clock()
	end
end

function SpawnRocketTurret(x, y, id, team)
	local Wall = SpawnObject(3, x, y, id)
	if Wall then
		local Turret = {
			Image = {
				image("gfx/flare3.bmp", 0, 1, 1),
				image("gfx/weapons/rocketlauncher.bmp<m>", 0, 1, 1),
			},
			Team = team or player(id, "team") or 0,
			Player = id or 0,
			Target = 0,
			LastFire = os.clock(),
			LastTween = os.clock(),
			LastTarget = os.clock(),
			x = x*32 + 16,
			y = y*32 + 16,
			tx = x,
			ty = y,
			ID = Wall,
		}
		imagecolor(Turret.Image[1], unpack(TurretTeamColor[Turret.Team]))
		imageblend(Turret.Image[1], 1)
		imagepos(Turret.Image[1], Turret.x, Turret.y, 0)
		imagepos(Turret.Image[2], Turret.x, Turret.y, 0)
		tween_rotateconstantly(Turret.Image[1], 3)

		setmetatable(Turret, RocketTurretMT)
		Turrets[Wall] = Turret
		return Wall
	end
end

FlashTurret = {}
FlashTurret.FireDelay = 1
FlashTurret.TweenDelay = 0.3
FlashTurret.TargetDelay = 0.4
FlashTurretMT = {__index = FlashTurret}
function FlashTurret:Fire()
	local ObjectRot = object(self.Image[2], "rot")
	local RadAngle = math.rad(ObjectRot)
	local ShootX = self.x + math.sin(RadAngle) * 32
	local ShootY = self.y - math.cos(RadAngle) * 32
	parse("spawnprojectile "..self.Player.." 52 "..ShootX.." "..ShootY.." "..self.TargetDistance.." "..ObjectRot)
end

function FlashTurret:TargetAble(id)
	if game("sv_gamemode") == "1" then
		return object(self.ID, "player") ~= id
	end
	return self.Team ~= player(id, "team")
end

function FlashTurret:Visible(id)
	return player(id, "health") > 0 and math.abs(player(id, "x") - self.x) < 320 and math.abs(player(id, "y") - self.y) < 240 and ObjectFreeline(self.x, self.y, player(id,"x"), player(id,"y"))
end

function FlashTurret:Update()
	local Angle = object(self.Image[2], "rot")
	if os.clock() - self.LastTarget >= self.TargetDelay then
		local ClosestTarget
		for _, id in pairs(player(0,"tableliving")) do
			if self:TargetAble(id) and self:Visible(id) then
				local Distance = math.sqrt((self.x - player(id, "x"))^2 + (self.y - player(id,"y"))^2)
				if not ClosestTarget or Distance < ClosestTarget[2] then
					ClosestTarget = {id, Distance}
				end
			end
		end
		self.Target = ClosestTarget and ClosestTarget[1] or 0
		self.TargetDistance = ClosestTarget and ClosestTarget[2] or 0
		self.LastTarget = os.clock()
	end

	if player(self.Target, "exists") then
		Angle = math.deg(AngleBetween(self.x, self.y, player(self.Target, "x"), player(self.Target, "y")))
	end

	if os.clock() - self.LastTween >= self.TweenDelay then
		if object(self.Image[2], "rot") ~= Angle then
			tween_rotate(self.Image[2], self.TweenDelay * 1000 - 20, Angle)
		end
		self.LastTween = os.clock()
	end

	if os.clock() - self.LastFire >= self.FireDelay and player(self.Target, "exists") and self:Visible(self.Target) then
		self:Fire()
		self.LastFire = os.clock()
	end
end

function SpawnFlashTurret(x, y, id, team)
	local Wall = SpawnObject(3, x, y, id)
	if Wall then
		local Turret = {
			Image = {
				image("gfx/flare3.bmp", 0, 1, 1),
				image("gfx/weapons/flashbang.bmp<m>", 0, 1, 1),
			},
			Team = team or player(id, "team") or 0,
			Player = id or 0,
			Target = 0,
			LastFire = os.clock(),
			LastTween = os.clock(),
			LastTarget = os.clock(),
			x = x*32 + 16,
			y = y*32 + 16,
			tx = x,
			ty = y,
			ID = Wall,
		}
		imagecolor(Turret.Image[1], unpack(TurretTeamColor[Turret.Team]))
		imageblend(Turret.Image[1], 1)
		imagepos(Turret.Image[1], Turret.x, Turret.y, 0)
		imagepos(Turret.Image[2], Turret.x, Turret.y, 0)
		tween_rotateconstantly(Turret.Image[1], 3)

		setmetatable(Turret, FlashTurretMT)
		Turrets[Wall] = Turret
		return Wall
	end
end

HETurret = {}
HETurret.FireDelay = 1
HETurret.TweenDelay = 0.3
HETurret.TargetDelay = 0.4
HETurretMT = {__index = HETurret}
function HETurret:Fire()
	local ObjectRot = object(self.Image[2], "rot")
	local RadAngle = math.rad(ObjectRot)
	local ShootX = self.x + math.sin(RadAngle) * 32
	local ShootY = self.y - math.cos(RadAngle) * 32
	parse("spawnprojectile "..self.Player.." 51 "..ShootX.." "..ShootY.." "..self.TargetDistance.." "..ObjectRot)
end

function HETurret:TargetAble(id)
	if game("sv_gamemode") == "1" then
		return object(self.ID, "player") ~= id
	end
	return self.Team ~= player(id, "team")
end

function HETurret:Visible(id)
	return player(id, "health") > 0 and math.abs(player(id, "x") - self.x) < 320 and math.abs(player(id, "y") - self.y) < 240 and ObjectFreeline(self.x, self.y, player(id,"x"), player(id,"y"))
end

function HETurret:Update()
	local Angle = object(self.Image[2], "rot")
	if os.clock() - self.LastTarget >= self.TargetDelay then
		local ClosestTarget
		for _, id in pairs(player(0,"tableliving")) do
			if self:TargetAble(id) and self:Visible(id) then
				local Distance = math.sqrt((self.x - player(id, "x"))^2 + (self.y - player(id,"y"))^2)
				if not ClosestTarget or Distance < ClosestTarget[2] then
					ClosestTarget = {id, Distance}
				end
			end
		end
		self.Target = ClosestTarget and ClosestTarget[1] or 0
		self.TargetDistance = ClosestTarget and ClosestTarget[2] or 0
		self.LastTarget = os.clock()
	end

	if player(self.Target, "exists") then
		Angle = math.deg(AngleBetween(self.x, self.y, player(self.Target, "x"), player(self.Target, "y")))
	end

	if os.clock() - self.LastTween >= self.TweenDelay then
		if object(self.Image[2], "rot") ~= Angle then
			tween_rotate(self.Image[2], self.TweenDelay * 1000 - 20, Angle)
		end
		self.LastTween = os.clock()
	end

	if os.clock() - self.LastFire >= self.FireDelay and player(self.Target, "exists") and self:Visible(self.Target) then
		self:Fire()
		self.LastFire = os.clock()
	end
end

function SpawnHETurret(x, y, id, team)
	local Wall = SpawnObject(3, x, y, id)
	if Wall then
		local Turret = {
			Image = {
				image("gfx/flare3.bmp", 0, 1, 1),
				image("gfx/weapons/he.bmp<m>", 0, 1, 1),
			},
			Team = team or player(id, "team") or 0,
			Player = id or 0,
			Target = 0,
			LastFire = os.clock(),
			LastTween = os.clock(),
			LastTarget = os.clock(),
			x = x*32 + 16,
			y = y*32 + 16,
			tx = x,
			ty = y,
			ID = Wall,
		}
		imagecolor(Turret.Image[1], unpack(TurretTeamColor[Turret.Team]))
		imageblend(Turret.Image[1], 1)
		imagepos(Turret.Image[1], Turret.x, Turret.y, 0)
		imagepos(Turret.Image[2], Turret.x, Turret.y, 0)
		tween_rotateconstantly(Turret.Image[1], 3)

		setmetatable(Turret, HETurretMT)
		Turrets[Wall] = Turret
		return Wall
	end
end

GasTurret = {}
GasTurret.FireDelay = 5
GasTurret.TweenDelay = 0.3
GasTurret.TargetDelay = 0.4
GasTurretMT = {__index = GasTurret}
function GasTurret:Fire()
	local ObjectRot = object(self.Image[2], "rot")
	local RadAngle = math.rad(ObjectRot)
	local ShootX = self.x + math.sin(RadAngle) * 32
	local ShootY = self.y - math.cos(RadAngle) * 32
	parse("spawnprojectile "..self.Player.." 72 "..ShootX.." "..ShootY.." "..self.TargetDistance.." "..ObjectRot)
end

function GasTurret:TargetAble(id)
	if game("sv_gamemode") == "1" then
		return object(self.ID, "player") ~= id
	end
	return self.Team ~= player(id, "team")
end

function GasTurret:Visible(id)
	return player(id, "health") > 0 and math.abs(player(id, "x") - self.x) < 320 and math.abs(player(id, "y") - self.y) < 240 and ObjectFreeline(self.x, self.y, player(id,"x"), player(id,"y"))
end

function GasTurret:Update()
	local Angle = object(self.Image[2], "rot")
	if os.clock() - self.LastTarget >= self.TargetDelay then
		local ClosestTarget
		for _, id in pairs(player(0,"tableliving")) do
			if self:TargetAble(id) and self:Visible(id) then
				local Distance = math.sqrt((self.x - player(id, "x"))^2 + (self.y - player(id,"y"))^2)
				if not ClosestTarget or Distance < ClosestTarget[2] then
					ClosestTarget = {id, Distance}
				end
			end
		end
		self.Target = ClosestTarget and ClosestTarget[1] or 0
		self.TargetDistance = ClosestTarget and ClosestTarget[2] or 0
		self.LastTarget = os.clock()
	end

	if player(self.Target, "exists") then
		Angle = math.deg(AngleBetween(self.x, self.y, player(self.Target, "x"), player(self.Target, "y")))
	end

	if os.clock() - self.LastTween >= self.TweenDelay then
		if object(self.Image[2], "rot") ~= Angle then
			tween_rotate(self.Image[2], self.TweenDelay * 1000 - 20, Angle)
		end
		self.LastTween = os.clock()
	end

	if os.clock() - self.LastFire >= self.FireDelay and player(self.Target, "exists") and self:Visible(self.Target) then
		self:Fire()
		self.LastFire = os.clock()
	end
end

function SpawnGasTurret(x, y, id, team)
	local Wall = SpawnObject(3, x, y, id)
	if Wall then
		local Turret = {
			Image = {
				image("gfx/flare3.bmp", 0, 1, 1),
				image("gfx/weapons/gasgrenade.bmp<m>", 0, 1, 1),
			},
			Team = team or player(id, "team") or 0,
			Player = id or 0,
			Target = 0,
			LastFire = os.clock(),
			LastTween = os.clock(),
			LastTarget = os.clock(),
			x = x*32 + 16,
			y = y*32 + 16,
			tx = x,
			ty = y,
			ID = Wall,
		}
		imagecolor(Turret.Image[1], unpack(TurretTeamColor[Turret.Team]))
		imageblend(Turret.Image[1], 1)
		imagepos(Turret.Image[1], Turret.x, Turret.y, 0)
		imagepos(Turret.Image[2], Turret.x, Turret.y, 0)
		tween_rotateconstantly(Turret.Image[1], 3)

		setmetatable(Turret, GasTurretMT)
		Turrets[Wall] = Turret
		return Wall
	end
end

SnowBallTurret = {}
SnowBallTurret.FireDelay = 0.3
SnowBallTurret.TweenDelay = 0.3
SnowBallTurret.TargetDelay = 0.4
SnowBallTurretMT = {__index = SnowBallTurret}
function SnowBallTurret:Fire()
	local ObjectRot = object(self.Image[2], "rot")
	local RadAngle = math.rad(ObjectRot)
	local ShootX = self.x + math.sin(RadAngle) * 32
	local ShootY = self.y - math.cos(RadAngle) * 32
	parse("spawnprojectile "..self.Player.." 75 "..ShootX.." "..ShootY.." "..self.TargetDistance.." "..ObjectRot)
end

function SnowBallTurret:TargetAble(id)
	if game("sv_gamemode") == "1" then
		return object(self.ID, "player") ~= id
	end
	return self.Team ~= player(id, "team")
end

function SnowBallTurret:Visible(id)
	return player(id, "health") > 0 and math.abs(player(id, "x") - self.x) < 320 and math.abs(player(id, "y") - self.y) < 240 and ObjectFreeline(self.x, self.y, player(id,"x"), player(id,"y"))
end

function SnowBallTurret:Update()
	local Angle = object(self.Image[2], "rot")
	if os.clock() - self.LastTarget >= self.TargetDelay then
		local ClosestTarget
		for _, id in pairs(player(0,"tableliving")) do
			if self:TargetAble(id) and self:Visible(id) then
				local Distance = math.sqrt((self.x - player(id, "x"))^2 + (self.y - player(id,"y"))^2)
				if not ClosestTarget or Distance < ClosestTarget[2] then
					ClosestTarget = {id, Distance}
				end
			end
		end
		self.Target = ClosestTarget and ClosestTarget[1] or 0
		self.TargetDistance = ClosestTarget and ClosestTarget[2] or 0
		self.LastTarget = os.clock()
	end

	if player(self.Target, "exists") then
		Angle = math.deg(AngleBetween(self.x, self.y, player(self.Target, "x"), player(self.Target, "y")))
	end

	if os.clock() - self.LastTween >= self.TweenDelay then
		if object(self.Image[2], "rot") ~= Angle then
			tween_rotate(self.Image[2], self.TweenDelay * 1000 - 20, Angle)
		end
		self.LastTween = os.clock()
	end

	if os.clock() - self.LastFire >= self.FireDelay and player(self.Target, "exists") and self:Visible(self.Target) then
		self:Fire()
		self.LastFire = os.clock()
	end
end

function SpawnSnowBallTurret(x, y, id, team)
	local Wall = SpawnObject(3, x, y, id)
	if Wall then
		local Turret = {
			Image = {
				image("gfx/flare3.bmp", 0, 1, 1),
				image("gfx/weapons/snowball.bmp<m>", 0, 1, 1),
			},
			Team = team or player(id, "team") or 0,
			Player = id or 0,
			Target = 0,
			LastFire = os.clock(),
			LastTween = os.clock(),
			LastTarget = os.clock(),
			x = x*32 + 16,
			y = y*32 + 16,
			tx = x,
			ty = y,
			ID = Wall,
		}
		imagecolor(Turret.Image[1], unpack(TurretTeamColor[Turret.Team]))
		imageblend(Turret.Image[1], 1)
		imagepos(Turret.Image[1], Turret.x, Turret.y, 0)
		imagepos(Turret.Image[2], Turret.x, Turret.y, 0)
		tween_rotateconstantly(Turret.Image[1], 3)

		setmetatable(Turret, SnowBallTurretMT)
		Turrets[Wall] = Turret
		return Wall
	end
end

ObjectMaxHealth = {150,300,500,1000,2000,1000,1000,500,1000,nil,750,1000,500,500,1500}
RepairTurret = {}
RepairTurret.FireDelay = 0.7
RepairTurret.TweenDelay = 0.3
RepairTurret.TargetDelay = 0.4
RepairTurretMT = {__index = RepairTurret}
function RepairTurret:Fire()
	local PlayerID = object(self.ID, "player")
	if player(PlayerID, "exists") then
		if player(PlayerID, "money") >= 100 then
			for _, id in pairs(player(0, "table")) do
				if ((object(self.ID, "x") - player(id, "x"))^2 + (object(self.ID, "y") - player(id, "y"))^2)^0.5 < 400 then
					parse("sv_sound2 "..id.." player/repair.wav")
				end
			end
			parse("setmoney "..PlayerID.." "..player(PlayerID, "money") - 100)
		else
			return nil
		end
	end
	parse("damageobject "..self.Target.." -20 "..object(self.ID, "player"))
end

function RepairTurret:TargetAble(id)
	if id == self.ID then
		return false
	elseif game("sv_gamemode") == "1" then
		return object(self.ID, "player") == object(id, "player")
	elseif Turrets[id] then
		return self.Team == Turrets[id].Team
	end
	return self.Team == object(id, "team")
end

function RepairTurret:Visible(id)
	local MaxHealth = ObjectMaxHealth[object(id, "type")]
	if MaxHealth and object(id, "health") < MaxHealth then
		return math.abs(object(id,"tilex") - self.tx) <= 1 and math.abs(object(id, "tiley") - self.ty) <= 1
	end
end

function RepairTurret:Update()
	local Angle = object(self.Image[2], "rot")
	if os.clock() - self.LastTarget >= self.TargetDelay then
		local ClosestTarget
		local ObjectTable = {
			objectat(self.tx + 1, self.ty),
			objectat(self.tx - 1, self.ty),
			objectat(self.tx, self.ty + 1),
			objectat(self.tx, self.ty - 1),
			objectat(self.tx + 1, self.ty + 1),
			objectat(self.tx + 1, self.ty - 1),
			objectat(self.tx - 1, self.ty + 1),
			objectat(self.tx - 1, self.ty - 1),
		}
		for _, id in pairs(ObjectTable) do
			if id > 0 then
				if self:TargetAble(id) and object(id, "team") == self.Team and self:Visible(id) then
					local Distance = object(id, "health")
					if not ClosestTarget or Distance < ClosestTarget[2] then
						ClosestTarget = {id, Distance}
					end
				end
			end
		end
		self.Target = ClosestTarget and ClosestTarget[1] or 0
		self.TargetDistance = ClosestTarget and ClosestTarget[2] or 0
		self.LastTarget = os.clock()
	end

	if object(self.Target, "exists") then
		Angle = math.deg(AngleBetween(self.x, self.y, object(self.Target, "x"), object(self.Target, "y")))
	end

	if os.clock() - self.LastTween >= self.TweenDelay then
		if object(self.Image[2], "rot") ~= Angle then
			tween_rotate(self.Image[2], self.TweenDelay * 1000 - 20, Angle)
		end
		self.LastTween = os.clock()
	end

	if os.clock() - self.LastFire >= self.FireDelay and object(self.Target, "exists") and self:Visible(self.Target) then
		self:Fire()
		self.LastFire = os.clock()
	end
end

function SpawnRepairTurret(x, y, id, team)
	local Wall = SpawnObject(3, x, y, id)
	if Wall then
		local Turret = {
			Image = {
				image("gfx/flare3.bmp", 0, 1, 1),
				image("gfx/weapons/wrench.bmp<m>", 0, 1, 1),
			},
			Team = team or player(id, "team") or 0,
			Player = id or 0,
			Target = 0,
			LastFire = os.clock(),
			LastTween = os.clock(),
			LastTarget = os.clock(),
			x = x*32 + 16,
			y = y*32 + 16,
			tx = x,
			ty = y,
			ID = Wall,
		}
		imagecolor(Turret.Image[1], unpack(TurretTeamColor[Turret.Team]))
		imageblend(Turret.Image[1], 1)
		imagepos(Turret.Image[1], Turret.x, Turret.y, 0)
		imagepos(Turret.Image[2], Turret.x, Turret.y, 0)
		tween_rotateconstantly(Turret.Image[1], 3)

		setmetatable(Turret, RepairTurretMT)
		Turrets[Wall] = Turret
		return Wall
	end
end

function SpawnNormalTurret(x, y, id, team)
	return SpawnObject(8, x, y, id, team)
end

function SpawnDelayTurret(Delay, F, x, y, id, team)
	local ConstructionSite = SpawnObject(10, x, y, id, team)
	if ConstructionSite then
		TurretsSpawned[ConstructionSite] = {Spawn = os.clock() + Delay - 1, F = F, x = x, y = y, id = id, team = team}
	end
end

addhook("ms100","UpdateTurrets")
function UpdateTurrets()
	for id, t in pairs(Turrets) do
		t:Update()
	end

	for Site, t in pairs(TurretsSpawned) do
		if os.clock() - t.Spawn >= 0 then
			TurretsSpawned[Site] = nil
			parse("killobject "..Site)
			t.F(t.x, t.y, t.id, t.team)
		end
	end
end

addhook("startround", "RemoveTurrets")
function RemoveTurrets()
	Turrets = {}
end

addhook("objectkill", "DestroyTurrets")
function DestroyTurrets(id, dmg, ply)
	local Turret = Turrets[id]
	if Turret then
		for _, Image in pairs(Turret.Image) do
			freeimage(Image)
		end
		Turrets[id] = nil
	end

	local Site = TurretsSpawned[id]
	if Site then
		TurretsSpawned[id] = nil
	end
end

if Fastbuild_mod then
	addhook("menu","FastBuildTurret")
	function FastBuildTurret(id, men, b)
		if men == "Choose Turret" then
			local x, y = unpack(USERTEMP[id]["tpbuildplace"])
			USERTEMP[id]["tpbuildplace"] = nil

			if b == 0 then return nil end
			if math.abs(player(id,"tilex") - x) > 1 or math.abs(player(id,"tiley") - y) > 1 then
				return msg2(id, "255000000You can't build here@C")
			end

			if player(id, "money") > 5000 then
				parse("setmoney "..id.." "..player(id, "money") - 5000)
			else
				return msg2(id, "255000000You have insufficient funds@C")
			end

			if SERVER_DATA["fastbuild"] then
				if b == 1 then
					SpawnRocketTurret(x, y, id)
				elseif b == 2 then
					SpawnFlashTurret(x, y, id)
				elseif b == 3 then
					SpawnGasTurret(x, y, id)
				elseif b == 4 then
					SpawnSnowBallTurret(x, y, id)
				elseif b == 5 then
					SpawnRepairTurret(x, y, id)
				elseif b == 6 then
					SpawnHETurret(x, y, id)
				elseif b == 7 then
					SpawnNormalTurret(x, y, id)
				end
			else
				if b == 1 then
					SpawnDelayTurret(3, SpawnRocketTurret, x, y, id)
				elseif b == 2 then
					SpawnDelayTurret(3, SpawnFlashTurret, x, y, id)
				elseif b == 3 then
					SpawnDelayTurret(3, SpawnGasTurret, x, y, id)
				elseif b == 4 then
					SpawnDelayTurret(3, SpawnSnowBallTurret, x, y, id)
				elseif b == 5 then
					SpawnDelayTurret(3, SpawnRepairTurret, x, y, id)
				elseif b == 6 then
					SpawnDelayTurret(3, SpawnHETurret, x, y, id)
				elseif b == 7 then
					SpawnDelayTurret(3, SpawnNormalTurret, x, y, id)
				end
			end
		end
	end

	function Fastbuild_mod(id,t,x,y,m)
		if SERVER_DATA["fastbuild"] then
			if t == 8 then
				USERTEMP[id]["tpbuildplace"] = {x, y}
				menu(id, "Choose Turret,Rocket Turret,Flashbang Turret,Gas Turret,Snowball Turret,Repair Turret,HE Turret,Normal Turret")
				return 1
			elseif t >= 1 and t <= 15 then
				parse("spawnobject "..t.." "..x.." "..y.." "..player(id,"rot").." "..m.." "..player(id,"team").." "..id)
				return 1
			end
		elseif t == 8 then
			USERTEMP[id]["tpbuildplace"] = {x, y}
			menu(id, "Choose Turret,Rocket Turret,Flashbang Turret,Gas Turret,Snowball Turret,Repair Turret,HE Turret,Normal Turret")
			return 1
		end
	end
else
	addhook("menu","FastBuildTurret")
	function FastBuildTurret(id, men, b)
		if men == "Choose Turret" then
			local x, y = unpack(TPBuildPlace[id])
			TPBuildPlace[id] = nil

			if b == 0 then return nil end
			if math.abs(player(id,"tilex") - x) > 1 or math.abs(player(id,"tiley") - y) > 1 then
				return msg2(id, "255000000You can't build here@C")
			end

			if player(id, "money") > 5000 then
				parse("setmoney "..id.." "..player(id, "money") - 5000)
			else
				return msg2(id, "255000000You have insufficient funds@C")
			end

			if b == 1 then
				SpawnDelayTurret(3, SpawnRocketTurret, x, y, id)
			elseif b == 2 then
				SpawnDelayTurret(3, SpawnFlashTurret, x, y, id)
			elseif b == 3 then
				SpawnDelayTurret(5, SpawnGasTurret, x, y, id)
			elseif b == 4 then
				SpawnDelayTurret(3, SpawnSnowBallTurret, x, y, id)
			elseif b == 5 then
				SpawnDelayTurret(3, SpawnRepairTurret, x, y, id)
			elseif b == 6 then
				SpawnDelayTurret(3, SpawnHETurret, x, y, id)
			elseif b == 7 then
				SpawnDelayTurret(3, SpawnNormalTurret, x, y, id)
			end
		end
	end

	TPBuildPlace = {}
	addhook("build","FastBuildBuild")
	function FastBuildBuild(id, t, x, y, m, oid)
		if t == 8 then
			TPBuildPlace[id] = {x, y}
			menu(id, "Choose Turret,Rocket Turret,Flashbang Turret,Gas Turret,Snowball Turret,Repair Turret,HE Turret,Normal Turret")
			return 1
		end
	end
end
